############################################################################### 
  # Script neve	: stecker.pl
# Feladata      : Az IPStecker dugaljak vezrlse http-n
# Ksztette	  : www.procontrol.hu, Kiss Endre, Glzik dm
# Dtum		      : 2013.12.09
# Verzi	      : 1.2.0
############################################################################### 
#!/usr/bin/perl -w

use strict;
use Socket;

# Globlis vltozk
my (                  # Paramter feldolgozshoz:
	$rip,		            # Parancssorban kapott IP cm	
	$paddr, 	          # Socket csatlakozshoz szksges
	$numArgs, 	        # A parancssori argumentumok szmnak trolsra
	$data_login,        # Parancssorbl kapott login cgi adatok
	$data_st_ctrl       # Parancssorbl kapott st_ctrl cgi adatok
);

  

############################################################################### 
# Fggvny neve : CmdLineProcess
# Feladata      : Parancsori argumentumok feldolgozsa
# Bemenet       : -
# Kimenet       : -
############################################################################### 
sub CmdLineProcess
{
  my($argnum);                                        # Ciklusvltoz
  $numArgs = $#ARGV + 1;	                            # A parancssori argumentumok szmt adja meg
	
	$rip = $ARGV[0];	                                  # Els paramter: IP cm
	
	foreach $argnum (1 .. $#ARGV) {                     # Tovbbi paramterek:
	   if ($ARGV[$argnum] =~ /plg/)  {                  # Dugalj kapcsols
	     $data_st_ctrl = join('&', $data_st_ctrl, $ARGV[$argnum]);
	   }
	   
	   if ($ARGV[$argnum] =~ /Pass=/) {                 # Jelsz
	     $data_login = substr $ARGV[$argnum], 5;
	   }
	 }
}




############################################################################### 
# Fggvny neve : ConnectToHost
# Feladata      : Kapcsolat ltrehozsa a Hoszt-tal
# Bemenet       : A clgp cme s a kapcsolat portja
# Kimenet       : -
# Plda         : ConnectToHost('192.168.0.11',1001)
############################################################################## 
sub ConnectToHost
{
	# Szksges vltozk ltrehozsa
	my ($remote,  $iaddr, $port, $proto);
	
	$iaddr = $0;
	$port  = $1;

	# Clgp cmnek megadsa
	$remote = shift || $iaddr;	
	printf "* Csatlakozas\t  $remote:";
	
	# Port megadsa
	$port = shift || 80;
	printf "$port";

	# Port tesztelse
	if ($port =~ /\D/) {
		$port = getservbyname($port, 'tcp')
	}
	die "Helytelen portnv" unless $port;

	$iaddr = inet_aton($remote) or die "helytelen hosztnv: $remote";
	$paddr = sockaddr_in($port, $iaddr);
	$proto = getprotobyname('tcp');
	
	#Socket kapcsolat ltrehozsa
	socket(SOCK, PF_INET, SOCK_STREAM, $proto) or die "socket: $!";

	#Csatlakozs a tvoli gphez
	connect(SOCK, $paddr) or die "Nem tudok csatlakozni a tvoli ghez!";
	print " Ok";
}




##############################################################################
# Fggvny neve : CloseConnection
# Feladata      : l socket kapcsolat lezra		
# Bemenet       : -
# Kimenet       : -
##############################################################################
sub CloseConnection
{
	close(SOCK) or die "Nincs nyitva a socket!";
}



##############################################################################
# Fggvny neve : Login
# Feladata      : Bejelentkezs webes felletre
# Bemenet       : -
# Kimenet       : -
##############################################################################
sub Login
{
	printf("\n* Bejelentkezes");
	$data_login = "GET /login.cgi?loginpass=" . $data_login . " HTTP/1.1\r\n\r\n\r\n\r\n";
	send(SOCK, $data_login,0,$paddr)
	or die "Nincs nyitva a SOCKET!"; 	
	print " Ok\r\n";
}


##############################################################################
# Fggvny neve : StCtrl
# Feladata	    : "Dugvillk" menpont kezelse 
# Bemenet	      : - 
# Kimenet	      : -
##############################################################################
sub StCtrl
{
  printf("\n* Dugvilla kezeles");
  $data_st_ctrl = "GET /st_ctrl.cgi?" . $data_st_ctrl . " HTTP/1.1\r\n\r\n\r\n\r\n";
	send(SOCK, $data_st_ctrl, 0, $paddr)
	or die "Nincs nyitva a SOCKET!";
	print " Ok\r\n"; 	
}



###################### Program start #########################################
printf "\n------Procontrol IPStecker Manager script------\n\n";

CmdLineProcess();

if ($data_login) {
  ConnectToHost("$rip",80);
  Login();
  CloseConnection;
}

if ($data_st_ctrl) {
  ConnectToHost("$rip",80);
  StCtrl();
  CloseConnection;
}

exit;
###################### Program end ###########################################

